#include <def21161.h>
#define JINX  0x1FF000	
#define PAUSE 0xfffFFF 	

/****************************************************************************/
/**** The following data sections have no real functionality but have    ****/
/**** been included into the project for demonstration purposes.         ****/
/**** They have been included to show how a user can easily propogate    ****/
/**** from one loader file tag section to the next when debugging Link   ****/
/**** port boot applications.Refer to Debugging Guidlines in EE-199 for  ****/
/**** further details.													 ****/
/****************************************************************************/

// The following data section declares 16-bit initialized data memory.
// This results in a link port loader tag of 0x4.
// Refer to figure 20 in EE-199 to see how this data section
// is loaded into internal memory.
.section /dm seg_dm_data16;
.var tag_word_0x4[16] = {0x1234, 0x1111, 0x2222, 0x3333, 
						 0x4444, 0x5555, 0x6666, 0x7777,
						 0x8888, 0x9999, 0xaaaa, 0xbbbb,
						 0xcccc, 0xdddd, 0xeeee, 0xffff};

// The following data section declares 16-bit zero-init data memory.
// This results in a link port loader tag of 0x1.
// Refer to figure 21 in EE-199 to see how this data section
// is loaded into internal memory.
.var tag_word_0x1[16];

// The following data section declares 32-bit initialized data memory.
// This results in a link port loader tag of 0x5.
// Refer to figure 22 in EE-199 to see how this data section
// is loaded into internal memory.
.section /dm seg_dm_data32;
.var tag_word_0x5[16] = {0x12345678, 0x11111111, 0x22222222, 0x33333333, 
						 0x44444444, 0x55555555, 0x66666666, 0x77777777,
						 0x88888888, 0x99999999, 0xaaaaaaaa, 0xbbbbbbbb,
						 0xcccccccc, 0xdddddddd, 0xeeeeeeee, 0xffffffff};

// The following data section declares 32-bit zero-init data memory.
// This results in a link port loader tag of 0x1.
// Refer to figure 23 in EE-199 to see how this data section
// is loaded into internal memory.						 
.var tag_word_0x2[16];

// The following data section declares 40-bit initialized data memory.
// This results in a link port loader tag of 0x6.
// Refer to figure 24 in EE-199 to see how this data section
// is loaded into internal memory.
.section /dm seg_dm_data40;
.var tag_word_0x6[16] = {0x123456789a, 0x1111111111, 0x2222222222, 0x3333333333, 
						 0x4444444444, 0x5555555555, 0x6666666666, 0x7777777777,
						 0x8888888888, 0x9999999999, 0xaaaaaaaaaa, 0xbbbbbbbbbb,
						 0xcccccccccc, 0xdddddddddd, 0xeeeeeeeeee, 0xffffffffff};

// The following data section declares 40-bit zero-init data memory.
// This results in a link port loader tag of 0x3.
// Refer to figure 25 in EE-199 to see how this data section
// is loaded into internal memory.							 
.var tag_word_0x3[16];

// The following data section declares 64-bit initialized data memory.
// This results in a link port loader tag of 0x6.
// Refer to figure 26 in EE-199 to see how this data section
// is loaded into internal memory.
.section /dm seg_dm_data64;
.var tag_word_0x10[16] = {0x9abcdef0, 0x12345678, 0x33333333, 0x22222222, 
						 0x55555555, 0x44444444, 0x77777777, 0x66666666,
						 0x99999999, 0x88888888, 0xbbbbbbbb, 0xaaaaaaaa,
						 0xdddddddd, 0xcccccccc, 0xffffffff, 0xeeeeeeee};

// The following data section declares 64-bit zero-init data memory.
// This results in a link port loader tag of 0x3.
// Refer to figure 27 in EE-199 to see how this data section
// is loaded into internal memory.							 
.var tag_word_0xF[16];

.section /pm seg_pm_code;
.global __main;
__main:
	r1=0xff00;
	dm(IOFLAG)=r1;	// set flags as outputs
	r2=-3;


__wayback:
// count up
	lcntr = 9; do __up until lce;
		r0 = DM(IOFLAG);
		r0 = btgl r0 by r1; 					/* toggle flag r1*/
		r0 = btgl r0 by r2; 					/* toggle flag r1*/
		DM(IOFLAG) = r0;
		lcntr=JINX; do __delay until lce; 		/*wait*/
			__delay:	nop;
		r1 = r1 + 1; 							/* increment which flag is toggled*/
__up:		r2 = r2 + 1;
	
// count down
	lcntr = 9; do __down until lce;
		r1 = r1 - 1; 							/* increment which flag is toggled*/
		r2 = r2 - 1;
		r0 = DM(IOFLAG);
		r0 = btgl r0 by r1; 					/* toggle flag r1*/
		r0 = btgl r0 by r2; 					/* toggle flag r1*/
		DM(IOFLAG) = r0;
		lcntr=JINX; do __delay2 until lce; 		/*wait*/
			__delay2:nop;
__down:	nop;

	lcntr = PAUSE; do __stylee until lce;
__stylee: nop;

	jump __wayback;
__main.end:


